/* TODO:
 * - Clean up code a lot!!!
 * - Implement "Quit slave" protocol
 */


#include <stdio.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <sys/ipc.h>

#include <curses.h>


#include "mediatool.h"

void Notice(char *text);
void Notice2(char *text1, char *text2);
void DoNotice(char *message);
void ClearKeys(void);
void dtfatal(char *text);

char	KeyStatString[33];

int main(char argc, char **argv)
{
  MediaCon  m;
  unsigned char read_char;
  int32		read_int,ret;
  char		RedisplayKeys = 0;
  char		filename[256];
  char		MediaIdStr[20];
  MdCh_KEYS	*KeysChunk;
  MdCh_STAT	*StatChunk;
  int32		*StatStatPtr;

  char		NameTracker[]="./tracker";
  char		MediaOption[]="-media";

  /* Theese variables deal with starting client programs (players) */
  char		*(Parameters[10]);
  pid_t		clone_pid;



  MdConnectInit();
  MdConnectNew(&m);
  if ( m.shm_adr == NULL )
    dtfatal("Could not create media connection.\n");


  KeysChunk   = FindChunkData(m.shm_adr, "KEYS");
  StatChunk   = FindChunkData(m.shm_adr, "STAT");
  StatStatPtr = &(StatChunk->status);

  ClearKeys();

  initscr(); cbreak(); noecho();
  nonl();
  intrflush(stdscr, FALSE);
  keypad(stdscr, TRUE);
                          

  erase();
  mvaddstr(0,0, "CMedia V0.10\n");
  addstr("---------------------------------------------------------------\n");
  addstr("+ Next Track          -     Previous Track\n");
  addstr("< Backward            >     Forward\n");
  addstr("P (Un)Pause (n/a)     Space Stop (n/a)\n");
  addstr("p Play/Stop (n/a)     q     Quit\n\n");
  addstr("F Enter Filename      C     Call player (tracker)\n");
  addstr("\n");
  addstr("---------------------------------------------------------------\n");
  refresh();

  while (1)
    {
      read_int=getch();
      read_char = (char)read_int;
      if ( read_char=='q' )
	/* exit gracefully on "Quit"*/
	break;

      switch (read_char)
	{
	case '+':
	  EventCounterRaise(&(KeysChunk->nexttrack),1);
	  RedisplayKeys = 1;
	  Notice("Next Track");
	  break;
	case '-':
	  EventCounterRaise(&(KeysChunk->prevtrack),1);
	  Notice("Previous Track");
	  RedisplayKeys = 1;
	  break;
	case ' ':
	  EventCounterRaise(&(KeysChunk->stop),1);
	  Notice("Full stop.");
	  RedisplayKeys = 1;
	  break;
	case '>':
	  EventCounterRaise(&(KeysChunk->forward),1);
	  RedisplayKeys = 1;
	  Notice("Forward");
	  break;
	case '<':
	  EventCounterRaise(&(KeysChunk->backward),1);
	  RedisplayKeys = 1;
	  Notice("Backward");
	  break;
	case 'p':	/* play (+unpause) */
	  /* play/pause/unpause */
	  if ( KeysChunk->pause )
	    {
	      KeysChunk->pause = 0;
	      EventCounterRaise(&(KeysChunk->play),1);
	      Notice( "Playing" ); /* unpaused, playing */
	    }
	  else
	    {
	      if  ( *StatStatPtr & MD_STAT_PLAYING )
		{
		  KeysChunk->pause = 1;
		  Notice("Paused");
		}
	      else
		{
		  EventCounterRaise(&(KeysChunk->play),1);
		  Notice("Playing");
		}
	    }
	  RedisplayKeys = 1;
	  break;
	case 'P':	/* (Un)pause */
	  if ( KeysChunk->pause )
	    {
	      KeysChunk->pause = 0;
	      Notice("Unpaused");
	    }
	  else
	    {
	      KeysChunk->pause = 1;
	      Notice("Pause");
	    }
	  RedisplayKeys = 1;
	  break;
	case 'F':	/* Enter Filename */
	  mvaddstr(13,0, "Enter Filename: ");
	  getstr(filename);
	  Notice2("Filename set to:", filename);
	  break;
	case 'C':	/* Call player */
	  Notice("Forking off new process.");
	  clone_pid = fork();

	  if ( clone_pid == -1 )
	    {
	      /*
	       * OOPS. Forking failed. Why it failed is recorded in "errno". But
	       * I don't care and just print out a message.
	       */
	      Notice("Forking failed.");
	    }
	  else
	    {
	      if ( clone_pid != 0 )
		{
		  /*
		   * PID != -1 && PID != 0: "clone_pid" contains the pid of the
		   * newly created process. Only the old process, which succesfully
		   * forked off a new process, comes here.
		   */
		  Notice("Forking finished, waiting for player init.");
		  while ( StatChunk->status == 0 ) /* do nothing */;

		  if ( StatChunk->status & MD_STAT_EXITED)
		    /* Something has gone wrong. The player exited directly. :-( */
		    Notice("Direct player exit. :-(");
		  else
		    Notice("Player started succesfully. :-)");
		}
	      else
		{
		  /*
		   * PID is 0: Only the newly created child process comes here.
		   * As the new process is identical to the old, replace it now with
		   * the "player" process. For this purpose, I prepare the argv[]
		   * array now.
		   */
		  sprintf(MediaIdStr,"%i", m.talkid);
		  Parameters[0]=NameTracker;
		  Parameters[1]=MediaOption;
		  Parameters[2]=MediaIdStr;
		  Parameters[3]=filename;
		  Parameters[4]=NULL;
		  /* Notice("Replacing forked process by player."); */
		  /* The new process should not print anything to the terminal or read
		   * characters from there.
		   */
		  freopen("/dev/null", "w", stdout);
		  freopen("/dev/null", "w", stderr);
		  freopen("/dev/null", "r", stdin);
		  ret = execvp("tracker", &Parameters);
		  /*
		   * Usually, the newly created process is now exchanged with <player>. So
		   * we will never come along here. Exept (!) when exec() fails, due to an
		   * non-existing <player>-executable, or some other weird thing.
		   */
		  dtfatal ("Ooops, exec() returned. This should not happen.\n");
		}
	    }
	  Notice("Mediatool continues execution.");
	  break;
	}

      if ( RedisplayKeys == 1 )
	{
	  /* do nothing
	  RedisplayKeys = 0;
	  KeyStatus = *KeyStatPtr;
	  for ( i=0; i<32; i++ )
	    {
	      if ( (KeyStatus & 1) == 1)
		KeyStatString[i] = '*' ;
	      else
		KeyStatString[i] = '-' ;
	      KeyStatus /= 2;
	    }
	  KeyStatString[32] = 0;
	  mvaddstr(17,0, KeyStatString);
	  */
	}
      refresh();
    }
  /* exit gracefully on EOF */
  MdDisconnect(&m);
  endwin();
  exit(0);
}

void Notice2(char* text1, char *text2)
{
  char helpstring[256];
  snprintf(helpstring,255,"%s%10s", text1, text2);
  helpstring[255]=0;
  DoNotice(helpstring);
}
void Notice(char *text)
{
  char helpstring[256];
  snprintf(helpstring,255,"%40s", text);
  helpstring[255]=0;
  DoNotice(helpstring);
}

void DoNotice(char *message)
{
  mvaddstr(15,0, message);
  refresh();
}



/******************************************************************************
 *
 * Function:	ClearKeys()
 *
 * Task:	Set all keys to status "Unpressed"
 *
 * in:		-
 * 
 * out:		-
 *
 *****************************************************************************/
void ClearKeys(void)
{

}

void dtfatal(char *text)
{
  fprintf(stderr, "%s", text);
  exit(-1);
}


