/*
	$Id: kmedia.h,v 1.3 1996/11/27 03:19:44 ynlo Exp ynlo $

	$Log: kmedia.h,v $
	Revision 1.3  1996/11/27 03:19:44  ynlo
	Not much changed in this header

	Revision 1.2  1996/11/23 18:16:36  ynlo
	cleanUp() removed
	comments added

*/

/*
	kmedia.h : Class declaration 
	
	Written by Yat-Nam Lo 1996
*/

#include <qpushbt.h>
#include <qlcdnum.h>
#include <qlabel.h>
#include <qdialog.h>
#include <qapp.h>
#include <qtimer.h>
#include <qbitmap.h>
#include <qcombo.h>
#include <qmsgbox.h>
#include <qscrbar.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/utsname.h>
#include <unistd.h>
#include <mntent.h>
#include <sys/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>


#include <mediatool.h>

#ifdef QTBETA
#include <qtooltip.h>
#endif

class KMEDIA : public QWidget {
	Q_OBJECT
private:
	QPushButton	*playPB;	// Play/Pause button
	QPushButton	*stopPB;	// Stop button
	QPushButton	*prevPB;	// Previous track
	QPushButton	*nextPB;	// Next track
	QPushButton	*fwdPB;		// "Fast" forward
	QPushButton	*bwdPB;		// "Fast" rewind
	QPushButton	*quitPB;	// Quit button
	QPushButton	*replayPB;	// Replay button
	QPushButton	*ejectPB;	// Eject button
	QPushButton	*aboutPB;	// about button
	QPushButton	*statusPB;	// A disabled Status button
	QLCDNumber	*trackLCD;	// Track currently being played
	QLCDNumber	*trackTimeLCD;	// Time elapsed
	QLabel		*statusLA;	// Replaced by statusPB
	QLabel		*volLA;		// Volume level
	QTimer		*timer;		// Timer to update the time
	QTimer		*blinker;	// Make the LCD blink while pausing
	QTimer		*volTimer;	// Real-time volume updating
	QComboBox	*songListCB;	// Track listing
	QScrollBar	*volSB;		// Volume Bar
	int		volChnl;	// The mixer's CD channel
	int		mixerFd;	// The file descriptor of the mixer
	int		jump;		// in seconds

	QPushButton     *makeButton( int, int, int, int, const char * );
	void		initToolTip();
	void		initMediatool();
	void		dtfatal(char *text);
	void		drawPanel();
	void		loadBitmaps();
	void		setLCDColor( QLCDNumber *, const QColor&, 
				     const QColor&  );
	void		initMixer( const char *mixer = "/dev/mixer" );


public:
	KMEDIA( QWidget *parent = 0, const char *name = 0 );

public slots:
	void		playClicked();
	void		stopClicked();
	void		prevClicked();
	void		prevReleased();
	void		nextClicked();
	void		nextReleased();
	void		fwdClicked();
	void		fwdReleased();
       	void		bwdClicked();
       	void		bwdReleased();
	void		quitClicked();
	void		replayClicked();
	void 		cdMode();
	void		ejectClicked();
	void		trackSelected( int );
	void		aboutClicked();
	void		blink();
};
